summaryrefslogtreecommitdiffstats
path: root/package/wget2nand/src
diff options
context:
space:
mode:
authorflorian <florian@3c298f89-4303-0410-b956-a3cf2f4a3e73>2007-05-11 22:15:06 +0000
committerflorian <florian@3c298f89-4303-0410-b956-a3cf2f4a3e73>2007-05-11 22:15:06 +0000
commitb7ff990b64c2ee57be79dac95eb1bf732bec28d8 (patch)
tree17c6d4b9d3b4a4bccb263a393eb43c7da1791bb9 /package/wget2nand/src
parent3786a154ba89635a2fe620d0e9547a2eedeec6a2 (diff)
Add wget2nand from David Goodenough, useful for RouterOS to OpenWrt migration
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@7192 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/wget2nand/src')
-rwxr-xr-xpackage/wget2nand/src/wget2nand71
1 files changed, 71 insertions, 0 deletions
diff --git a/package/wget2nand/src/wget2nand b/package/wget2nand/src/wget2nand
new file mode 100755
index 000000000..5197dbad8
--- /dev/null
+++ b/package/wget2nand/src/wget2nand
@@ -0,0 +1,71 @@
+#!/bin/sh
+# wget2nand
+# This script can be used to download a TGZ file from your build system which
+# contains the files to be installed on the NAND flash on your RB1xx card.
+# The one parameter is the URL of the TGZ file to be downloaded.
+# Licence GPL V2
+# Author david.goodenough@linkchoose.co.uk
+# Based on cf2nand from RB532 support
+. /etc/functions.sh
+
+[ -d /tmp/wget2nand ] && {
+ echo "/tmp/wget2nand already exists"
+ exit 1
+}
+
+# first get an address for eth0 using udhcpc
+killall udhcpc
+/sbin/udhcpc -i eth0
+
+# need to find the wget server from the command line
+url=$1
+[ -z "$url" ] && {
+ echo "No URL specified for image TGZ"
+ echo "Usage : $0 URL"
+ exit 1
+}
+
+boot="$(find_mtd_part 'RouterBoard NAND Boot')"
+main="$(find_mtd_part 'RouterBoard NAND Main')"
+[ -z "$boot" -o -z "$main" ] && {
+ echo "Cannot find NAND Flash partitions"
+ exit 1
+}
+
+echo "Erasing filesystem."
+mtd erase Boot 2>/dev/null >/dev/null
+mtd erase Main 2>/dev/null >/dev/null
+
+echo "Mounting $main as new root and $boot as boot partition"
+
+mkdir /tmp/wget2nand/
+mkdir /tmp/wget2nand-boot
+mount -t yaffs2 "$main" /tmp/wget2nand/
+mount -t yaffs2 "$boot" /tmp/wget2nand-boot
+
+echo "Copying filesystem..."
+( wget -O - $url/openwrt-adm5120-2.6-rootfs.tgz) | ( cd /tmp/wget2nand/; tar xvz )
+wget -O /tmp/wget2nand-boot/kernel $url/openwrt-adm5120-2.6-vmlinux
+
+# update the command line on the kernel to boot from the right place
+[ ! -e /sbin/patch-cmdline ] && {
+ echo "Cannot find patch-cmdline"
+ exit 1
+}
+
+echo "Patching the kernel command line"
+/sbin/patch-cmdline /tmp/wget2nand-boot/kernel "root=/dev/mtdblock1 rootfstype=yaffs2 init=/etc/preinit "
+chmod +x /tmp/wget2nand-boot/kernel
+
+# make sure everything is written before we unmount the partitions
+sync
+ls /tmp/wget2nand-boot/
+ls /tmp/wget2nand/
+# unmount the partitions and remove the directories into which they were mounted
+umount /tmp/wget2nand-boot
+umount /tmp/wget2nand
+rmdir /tmp/wget2nand-boot
+rmdir /tmp/wget2nand
+
+# all done
+echo "Image written, you can now reboot. Remember to change the boot source to Boot from Nand"